#include "affichable.h"



NuageDePoints::NuageDePoints(Vertexcolornormal* tab,int nbrvecteurs, int nbrmaxvecteurs){
    nbrvertex=nbrvecteurs;
    //génération du buffers d'informations de vertex
    glGenBuffers(1,&buffer);
    //selection du buffer
    glBindBuffer(GL_ARRAY_BUFFER, buffer);
    //allocation du buffer
    glBufferData(GL_ARRAY_BUFFER, nbrmaxvecteurs*sizeof(Vertexcolornormal), NULL, GL_DYNAMIC_DRAW);
    //remplissage du buffer
    glBufferSubData(GL_ARRAY_BUFFER, 0, nbrvecteurs*sizeof(Vertexcolornormal), (GLfloat*)tab);
}

void NuageDePoints::affiche()const{
    glBindBuffer(GL_ARRAY_BUFFER, buffer);
    glVertexPointer( 3, GL_FLOAT,sizeof(Vertexcolornormal),0);
    glColorPointer( 4, GL_UNSIGNED_BYTE, sizeof(Vertexcolornormal), (float*)NULL +(3) );
    // Activation d'utilisation des tableaux
    glEnableClientState( GL_VERTEX_ARRAY );
    glEnableClientState( GL_COLOR_ARRAY );
    glEnableClientState( GL_NORMAL_ARRAY );
    glDrawArrays(GL_POINTS,0,nbrvertex);//affichage des points sans element_arrays

    glDisableClientState( GL_NORMAL_ARRAY );
    glDisableClientState( GL_COLOR_ARRAY );
    glDisableClientState( GL_VERTEX_ARRAY );
}

void NuageDePoints::realloc(Vertexcolornormal* tab,int nbrvecteurs, int nbrmaxvecteurs){
    nbrvertex=nbrvecteurs;
    glBindBuffer(GL_ARRAY_BUFFER, buffer);
    glBufferData(GL_ARRAY_BUFFER, nbrmaxvecteurs*sizeof(Vertexcolornormal), NULL, GL_DYNAMIC_DRAW);
    glBufferSubData(GL_ARRAY_BUFFER, 0, nbrvecteurs*sizeof(Vertexcolornormal), (GLfloat*)tab);
}

void NuageDePoints::subdata(Vertexcolornormal* tab,int nbrvecteurs){
    nbrvertex=nbrvecteurs;
    glBindBuffer(GL_ARRAY_BUFFER, buffer);
    glBufferSubData(GL_ARRAY_BUFFER, 0, nbrvecteurs*sizeof(Vertexcolornormal), (GLfloat*)tab);
}

Toile::Toile(Vertexcolornormal* tab,int nbrvecteurs,int* indices,int nbrindices){
    nbrvertex=nbrvecteurs;
    nbrsegments=nbrindices;
    vertextab=(GLfloat*)tab;
    segmenttab=indices;
    //génération du buffers d'informations de vertex
    glGenBuffers(2,buffer);
    //selection du buffer
    glBindBuffer(GL_ARRAY_BUFFER, buffer[0]);
    glBufferData(GL_ARRAY_BUFFER, nbrvecteurs*sizeof(Vertexcolornormal), NULL, GL_DYNAMIC_DRAW);
    glBufferSubData(GL_ARRAY_BUFFER, 0, nbrvecteurs*sizeof(Vertexcolornormal), (GLfloat*)tab);
    glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, buffer[1]);
    glBufferData(GL_ELEMENT_ARRAY_BUFFER, nbrindices*2*sizeof(int), NULL, GL_DYNAMIC_DRAW);
    glBufferSubData(GL_ELEMENT_ARRAY_BUFFER, 0, nbrindices*2*sizeof(int), (GLint*)indices);
}


void Toile::affiche()const{
    glBindBuffer(GL_ARRAY_BUFFER, buffer[0]);
    glVertexPointer( 3, GL_FLOAT,sizeof(Vertexcolornormal),0);
    glColorPointer( 4, GL_UNSIGNED_BYTE, sizeof(Vertexcolornormal), (float*)NULL +(3) );
    glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, buffer[1]);
    // Activation d'utilisation des tableaux
    glEnableClientState( GL_VERTEX_ARRAY );
    glEnableClientState( GL_COLOR_ARRAY );
    glEnableClientState( GL_NORMAL_ARRAY );
    glDrawElements(GL_LINES, nbrsegments*2, GL_UNSIGNED_INT, 0);

    glDisableClientState( GL_NORMAL_ARRAY );
    glDisableClientState( GL_COLOR_ARRAY );
    glDisableClientState( GL_VERTEX_ARRAY );
}
void Toile::grow(float dl){
    int k;
    for(k=0;k<nbrvertex;k++)
        (Vect3f&)((Vertexcolornormal*)vertextab)[k]+=dl*((Vertexcolornormal*)vertextab)[k].normale;

    glBindBuffer(GL_ARRAY_BUFFER, buffer[0]);
    glBufferSubData(GL_ARRAY_BUFFER, 0, nbrvertex*sizeof(Vertexcolornormal), (GLfloat*)vertextab);
    glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, buffer[1]);
    glBufferSubData(GL_ELEMENT_ARRAY_BUFFER, 0, nbrsegments*2*sizeof(int), (GLint*)segmenttab);
}





